/*=================================================================================
This file contains: 1) The main function main()
                       Aims: Declare variables, arrays.
					         Output results in .txt file.

                    2) The function input_data()
					   Aims: Provide a user input interface.
					         Check whether the data inputed is correct.

==================================================================================*/
#include <iostream>
#include <cmath>
#include <time.h>
#include <fstream>
using namespace std;

void input_data (double& T, int& N, int& m, double& T_1); //user input interface

void price_matrix (double *price, double *dividend, double *market_return, double niu, int num_obs, int m,double **pri_matrix);//The price for each risky asset during observation time T_1

void compute_fundamental (double **pri_matrix, int num_obs, double r, double *lamda_F_1); //Fundamental trader's investment proportions

void compute_noise (double& noise_intensity, double *lamda_N_1); //Noise trader's investment proportions

void compute_trend (double *market_return, int num_obs,  double r, double *lamda_T_1);//trend follower's investment porportions

void compute_dividend (double *dividend);//dividend for each risky asset
//compute wealth and price
void compute_wealth(double niu, double c, double r,int m, int num_obs, double **lamda, double *wealth, double **portfolio, double **pri_matrix, double *price, double *bank, double& noise_intensity, double *dividend, double *lamda_F_1,double *lamda_T_1,double *lamda_N_1, double *market_return);
void compute_wealth_flow(double beta, double niu, double c, double r,int m, double& totalwealth, int num_obs, double **lamda, double *wealth, double *population, double *pre_population, double **portfolio, double **pri_matrix, double *price,double *bank, double& noise_intensity,double *dividend, double *lamda_F_1,double *lamda_T_1,double *lamda_N_1, double *market_return);


double normal_variate (void);
int main ()
{
   double T,T_1; //T is the totol number of periods for the simulation, T_1 is investors' observation horizon
   int N,m,number_cut,number_divide,number_av;//N is the number of trades during T (For D2C version model use only). m is number of risky assets.
   double total,sum,totalwealth,noise_intensity;
   double rho; //rho controls the degree of recency bias in performance evaluation
   double r;// r is risk-free interest rate

   double noi,fundamental,tre, av_n, av_f, av_t, rs, ars, ars_per, av_rs, av_log_ars, av_vol, av_price, av_exreturn, variance, exvariance, av_std, av_exstd, std, exstd;
   double log_rs, log_ars, av_log_rs;

   noi=0;
   fundamental=0;
   tre=0;
   rs=0;
   log_rs=0;

    double port_temp[3];
	double sum_pop[3];
	double av_pop[3];
	
	double vol, total_vol, sum_vol;


	 for (int j=0; j<3; j++)
		 av_pop[j]=0;
   
   av_n=0;
   av_f=0;
   av_t=0;
   av_rs=0;
   av_log_rs=0;
   av_log_ars=0;
   av_vol=0;
    av_std=0;


	av_exstd=0;
	av_price=0;
	av_exreturn=0;
 

   input_data (T, N, m, T_1);

   srand(1);
   double niu,c;
     r=0.001;
	 c=0.000999000999000999;
	
   //niu = T/(double)N; // length of time between two successive trades
	 niu = 1; //for standard version model
	 noise_intensity = 0;//initialising the noise trader
   
//memory allocation for investment proportion matrix (size K x I)
   double** lamda = new double*[m+1];
   for (int i=0; i<m+1; i++)
	   lamda[i]= new double[3]; 



  double* bank = new double[3]; // portfolios of the risk-free asset;

//memory allocation for portfolio matrix (size I x K)
   double** portfolio = new double*[3];
   for (int i=0; i<3; i++)
	   portfolio[i]= new double[m];

//memory allocation for investors' wealth
   double* wealth = new double[3];
 
	     wealth[0]=667;     //investors' inital wealth
	     wealth[1]=667;
		 wealth[2]=667;
		 
//memory allocation for dividends
   double* dividend = new double[m];

//memory allocation for observed price data set
   int num_obs=0;
   while(num_obs<=(T_1/niu)) num_obs++;
   
   double** pri_matrix = new double*[m];
    for (int i=0; i<m; i++)
	   pri_matrix[i]= new double[num_obs]; 

	 double* market_return = new double[num_obs-1];
   for (int i=0; i<num_obs-1; i++) 
	   market_return[i]=0;

   double* price = new double[m]; // prices 
	  
   double* lamda_F_1 = new double[m+1]; //investment proportions for the fundamental trader

   double* lamda_T_1 = new double[m+1];//trend follower

   double* lamda_N_1 = new double[m+1];//noise trader



	 double* population= new double [3];
	 double* pre_population= new double [3];
	 double w_return[3];
     double wealth_temp[3];
	 double invest_temp[3];
	
	double** fitness = new double*[3];
    for (int i=0; i<3; i++)
	   fitness[i]= new double[N];
	fitness[0][0]=0;
	fitness[1][0]=0;
	fitness[2][0]=0;


	double beta;
	gamma=0.0;
	rho=0.99;

	double beta; // beta=1 is flow of funds, beta=0 no flow of funds
	beta=1.0;

	number_cut=900000;
	number_divide = N - number_cut;
	

	double*  price_se = new double[N];
	double*  exreturn_se = new double[N];
	number_av=1;
	
	srand((unsigned)time(NULL));
   
    price_matrix (price,dividend,market_return,niu,num_obs,m,pri_matrix); //get stock prices for each stock during observation time T_1

ofstream myfile ("statistics.txt");
if (myfile.is_open())
{
  for(int z=0; z<2; z++)
	{ 
       gamma += 1.0;

		  // rho +=0.1;

/*
		   if (z==0)
		  beta=0;
		  

		if (z==1)
		    //beta=0.0001;
			beta=0.00000001;

			    if (z==2)
			//beta=0.001;
		 beta=0.00000005;

		    if (z==3)
			//beta=0.001;
		 beta=0.0000001;


	     if (z==4)
			//beta=0.001;
		 beta=0.0000005;

		  if (z==5)
			 //beta=0.01;
			 beta=0.000001;

		 if (z==6)
			 //beta=0.01;
			 beta=0.000005;

		  if (z==7)
			// beta=0.1;
			beta=0.00001;

		      if (z==8)
			// beta=1;
			beta=0.00005;

		    if (z==9)
			// beta=1;
			beta=0.0001;

			if (z==10)
				beta=0.001;

			if (z==11)
				beta=0.01;


*/




		  for (int j=0; j<3; j++)
		       av_pop[j]=0;
   
		   av_n=0;
		   av_f=0;
		   av_t=0;
		   av_rs=0;
		   av_log_rs=0;
		   av_log_ars=0;
		   av_vol=0;
		   av_std=0;
		   av_exstd=0;
	
	
 

		  for(int x=0; x<number_av; x++)
		  { 

				 wealth[0]=667;     //investors' inital wealth
				 wealth[1]=667;
				 wealth[2]=667;

				 fitness[0][0]=0;
				 fitness[1][0]=0;
				 fitness[2][0]=0;

				 noi=0;
				 fundamental=0;
				 tre=0;
				 rs=0;
				 ars=0;
				 log_rs=0;
				 log_ars=0;
				 sum_vol=0;
				 av_price=0;
				 variance=0; 
				 av_exreturn=0;
				 exvariance=0;
				
			


				 sum_pop[0]=0;
				 sum_pop[1]=0;
				 sum_pop[2]=0;

			  for (int k=0; k<m; k++)
			   {   
				   pri_matrix[k][0]=950/pow(1.0015,(num_obs-1));

				  for (int i=0; i<num_obs-1; i++)
				      pri_matrix[k][i+1]= pri_matrix[k][i]*1.0015;


				  for(int j = 0; j<num_obs-1; j++)
				   market_return[j]=(pri_matrix[k][j+1]+1)/pri_matrix[k][j];
				   

				  price[0]=pri_matrix[k][num_obs-1];
			  }

			 srand((unsigned)time(NULL));


					 compute_dividend (dividend);
					
					 compute_fundamental (pri_matrix,num_obs,r,lamda_F_1);
					 for (int i=0; i<m+1; i++)
						 lamda[i][1]=lamda_F_1[i];
						


					 compute_noise (noise_intensity, lamda_N_1);
					  for (int i=0; i<m+1; i++)
						 lamda[i][0]=lamda_N_1[i];
					

					 compute_trend (market_return, num_obs, r, lamda_T_1);
					 for (int i=0; i<m+1; i++)
						  lamda[i][2]=lamda_T_1[i];
					 						 
				/* Now investors investment proportions matrix has been assembled completely! */
					for (int i=0; i<3; i++)
						  invest_temp[i] = lamda[0][i];
						  
				
			
				 for(int i=0; i<N; i++)
				 { 
					total=0;
					sum=0;
						     
					  if (i==0)
					  {


						  for (int j=0; j<3; j++)
						   wealth_temp[j]=(1-c)*wealth[j];

					    compute_wealth(niu,c,r,m, num_obs, lamda, wealth, portfolio, pri_matrix, price,bank, noise_intensity,dividend,lamda_F_1,lamda_T_1,lamda_N_1,market_return);//get investors wealth
		               
		                 
						
						for (int j=0; j<3; j++)
						{
						   w_return[j]=wealth[j]/wealth_temp[j];
					       w_return[j]=log(w_return[j]);
						}
						
				
					    
						for(int j = 0; j < 3; j++)
							total += wealth[j];
						for(int j = 0; j < 3; j++)
						{
							pre_population[j] = wealth[j]/total;
							port_temp[j]=portfolio[j][0];
						}


					   }//end if i is 0



		       
					 if(i>0)
					 {
						 if (beta==0)
						  {
								for (int j=0; j<3; j++)
								  wealth_temp[j]=(1-c)*wealth[j];

							  compute_wealth(niu,c,r,m, num_obs, lamda, wealth, portfolio, pri_matrix, price,bank,noise_intensity,dividend,lamda_F_1,lamda_T_1,lamda_N_1,market_return);//get investors wealth
			               
							   for (int j=0; j<3; j++)
							    {
						          w_return[j]=wealth[j]/wealth_temp[j];
					              w_return[j]=log(w_return[j]);
						        }
										 
						   }else if( beta>0){

							   for (int j=0; j<3; j++)
								  wealth_temp[j]=wealth[j];

							total = 0;
							
							for (int j=0; j<3; j++)
							{
							 fitness[j][i]= w_return[j] + rho*fitness[j][i-1];
							}

							for(int j = 0; j < 3; j++)
							  total += wealth[j];

		                     
							for(int j = 0; j < 3; j++)
						       {
							       for(int k=0; k<3; k++)
								     sum += exp(gamma*(fitness[k][i]-fitness[j][i]));

						              population[j]= 1/sum;

						            sum=0;
						       }

													  
							totalwealth = total;

							compute_wealth_flow(beta,niu, c, r, m, totalwealth, num_obs, lamda, wealth, population, pre_population, portfolio, pri_matrix, price,bank, noise_intensity,dividend, lamda_F_1,lamda_T_1,lamda_N_1,market_return);

							 
							 for (int j=0; j<3; j++)
							 {
								 wealth_temp[j]=(1-c)*(beta*pre_population[j]*totalwealth + (1-beta)*wealth_temp[j]);
							
						         w_return[j]=wealth[j]/wealth_temp[j];
					             w_return[j]=log(w_return[j]);
					
								 port_temp[j]= fabs(portfolio[j][0]-port_temp[j]);
							 
							 }


							 total_vol=0;
							 vol=0;

							 for (int j=0; j<3; j++)
							  total_vol += port_temp[j];

							 vol= total_vol/2;


							 if(i>(number_cut-1))
							 {  
								 noi += w_return[0];
							     
								 fundamental += w_return[1];

								 tre += w_return[2];

								 rs += (market_return[num_obs-2]-1);

								 ars_per= pow(market_return[num_obs-2],52)-1;
								 ars += ars_per;
								 


								 log_rs += log(market_return[num_obs-2]);

								 log_ars += log(ars_per+1);

								 

								 sum_vol += vol;

								 price_se[i-number_cut]=price[0];
								 exreturn_se[i-number_cut]= log(market_return[num_obs-2])-0.0009995;

								 av_price += price_se[i-number_cut];
								 av_exreturn +=  exreturn_se[i-number_cut];
								  
								 for (int j=0; j<3; j++)
									 sum_pop[j] += (wealth_temp[j]/((1-c)*totalwealth));
							 }

							 

			                 
							 for (int j=0; j<3; j++)
							 {
								 pre_population[j] = population[j];
								 port_temp[j]=portfolio[j][0];

								
							 }
						  }//end if beta>0
					  }//end if i>0
		           
					 total=0;


					 for (int j=0; j<3; j++)//compute total wealth
						total += wealth[j]; 
					
				  }//end for N


				  av_n += (noi/number_divide);

				  av_f += (fundamental/number_divide);

				  av_t += (tre/number_divide);

				  av_rs += (rs/number_divide);

				  av_log_rs += (log_rs/number_divide);

				  av_log_ars += (log_ars/number_divide);

				  av_vol += (sum_vol/number_divide);

				  av_price = av_price/number_divide;
				  av_exreturn =  av_exreturn/number_divide;

				 

				   for (int j=0; j<3; j++)
					   av_pop[j] += (sum_pop[j]/number_divide) ;


					for (int j=0; j<number_divide; j++)
					{
					 variance += ((price_se[j]-av_price)*(price_se[j]-av_price))/(number_divide-1);
						
					 exvariance +=((exreturn_se[j]-av_exreturn)*(exreturn_se[j]-av_exreturn))/(number_divide-1);
					}

					 std= sqrt(variance);
					 exstd=sqrt(exvariance);
					   

					 av_std += std;
					 av_exstd += exstd;


					 
/*
        myfile<<"beta: "<<beta<<" gamma: "<<gamma<<endl;
		myfile<<"simple return: "<<rs/number_divide<<" "<<"log return: "<<log_rs/number_divide<<" anaulized log return "<<log_ars/number_divide<<endl;
		myfile<<"Price Std: "<<std<<" "<<"exreturn Std: "<<exstd<<endl;
		myfile<<" Average Volume: "<<sum_vol/number_divide<<" anaulized volume "<<52*sum_vol/number_divide<<endl;
		myfile<<"noise trader: "<<noi/number_divide<<" "<<"Average population: "<<sum_pop[0]/number_divide<<endl;
        myfile<<"Fundamental trader: "<<fundamental/number_divide<<" "<<"Average population: "<<sum_pop[1]/number_divide<<endl;
		myfile<<"Trend follower: "<<tre/number_divide<<" "<<"Average population: "<<sum_pop[2]/number_divide<<endl;

		//  cout<<"gamma: "<<beta<<" Average Volume: "<<av_vol/10<<endl;
		  
		   myfile<<"****************************************************************** "<<endl;
		   myfile<<"****************************************************************** "<<endl;
*/


		}//end for x
		myfile<<"beta: "<<beta<<" gamma: "<<gamma<<endl;
		myfile<<"market simple return: "<<av_rs/number_av<<" "<<"log return: "<<av_log_rs/number_av<<" anaulized log return "<<av_log_ars/number_av<<endl;
	    myfile<<"Price Std: "<<av_std/number_av<<" "<<"exreturn Std: "<<av_exstd/number_av<<endl;
		myfile<<" Average Volume: "<<av_vol/number_av<<" anaulized volume "<<52*av_vol/number_av<<endl;
		myfile<<"noise trader: "<<av_n/number_av<<" "<<"Average population: "<<av_pop[0]/number_av<<endl;
        myfile<<"Fundamental trader: "<<av_f/number_av<<" "<<"Average population: "<<av_pop[1]/number_av<<endl;
		myfile<<"Trend follower: "<<av_t/number_av<<" "<<"Average population: "<<av_pop[2]/number_av<<endl;

		//  cout<<"gamma: "<<beta<<" Average Volume: "<<av_vol/10<<endl;
		  
		   myfile<<"****************************************************************** "<<endl;
		   myfile<<"****************************************************************** "<<endl;


} //end for z

          
		   
myfile.close();//save and close .txt
		cout << "statistics.txt has been created"<<endl;
}//end if myfile
 else cout << "Unable to open file";



		  
	 int p;
  cin>>p;
  return 0;
}


void input_data (double& T, int& N, int& m, double& T_1)
{

  cout<<"Please enter the number of periods in the simulation:"<<endl;
  cin>>T; 
  while (T<=0)//check whether the time is negative or 0,if so, ask user re-input
    {
	  cout<<"You enter invailid time horizon! It must be positive!"<<endl;
      cout<<"Please enter positive time horizon again!"<<endl;
      cin>>T;
    }

//for D2C version model
/* 
  cout<<"Please enter the number of trades during the time horizon:"<<endl;
  cin>>N; 
  while (N<=0)//check whether the number is negative or 0, if so, ask user re-input
    {
	   cout<<"number of trades must be positive!"<<endl;
       cout<<"Please enter the number of trades again:"<<endl;
       cin>>N;
    }
*/ 
N=T;//for standard version with the length of time step = 1.

//for multi-asset model
/*
   cout<<"Please enter the number of stocks in the market:"<<endl;
  cin>>m; 
    while (m<2)//check whether the number of stocks is less than 2, if so, ask user re-input
    {
	   cout<<"number of stocks has to be greater than 1!"<<endl;
       cout<<"Please enter the number of stocks again:"<<endl;
       cin>>m;
    }
*/
m=1;//single risky asset model

  cout<<"Please enter the observation time:"<<endl;
  cin>>T_1; 
  while (T_1<=0)//check whether the time is negative or zero, if so, ask user re-input
    {
	   cout<<"Observation time must be positive!"<<endl;
       cout<<"Please enter the observation time again:"<<endl;
       cin>>T_1;
    }

}







