#include <iostream>
#include <cmath>
#include <time.h>
using namespace std;

double normal_variate (void);//compute standard normal sample
void price_matrix (double *price, double *dividend, double *market_return, double niu, int num_obs, int m,double **pri_matrix);
void compute_fundamental (double **pri_matrix, int num_obs, double r, double *lamda_F_1);
void compute_trend (double *market_return, int num_obs,  double r, double *lamda_T_1);
void portfolios(double **lamda, double *wealth, int m, double niu, double c, double r,double **portfolio, double *price, double *bank);//compute portfolio matrix and the realised stock price
void compute_dividend (double *dividend);//compute dividend for each stock
void MatrixInversion(double **A, int order, double **Y);//compute the inverse of the matrix
double CalcDeterminant( double **mat, int order);//compute the determinant of the matrix
int GetMinor(double **src, double **dest, int row, int col, int order);//calculate the cofactor of element (row,col)
void Matrix_Mult(double **A, double **B, int Arow, int Acol, int Bcol, double **the_matrix);// compute the mutiplication of matrices
void compute_noise (double& noise_intensity, double *lamda_N_1);



void compute_wealth(double niu, double c, double r,int m, int num_obs, double **lamda, double *wealth, double **portfolio, double **pri_matrix, double *price, double *bank, double& noise_intensity, double *dividend, double *lamda_F_1,double *lamda_T_1,double *lamda_N_1, double *market_return)
{
  double total,n_1,n_2,time_unit;
  total=0;

  time_unit=0.25;

  portfolios(lamda, wealth, m, niu, c,r, portfolio,price,bank); //compute portfolio matrix and the realised price

  price_matrix (price,dividend,market_return,niu,num_obs,m,pri_matrix);//get stock prices for risky asset during observation time T_1

  compute_dividend (dividend);//compute dividend

  
  compute_fundamental (pri_matrix,num_obs,r,lamda_F_1);
  for (int i=0; i<m+1; i++)
	  lamda[i][1]=lamda_F_1[i];

             
  compute_noise (noise_intensity, lamda_N_1);
    for (int i=0; i<m+1; i++)
		lamda[i][0]=lamda_N_1[i];
				
  compute_trend (market_return, num_obs, r, lamda_T_1);
	 for (int i=0; i<m+1; i++)
		 lamda[i][2]=lamda_T_1[i];
	

	
 
   double** the_matrix = new double*[3];
   for (int i=0; i<3; i++)
	   the_matrix[i]= new double[3]; 

   for (int i=0; i<3; i++)
	   for (int j=0; j<3; j++)
		     the_matrix[i][j] = 0;


   Matrix_Mult(portfolio, lamda, 3,m,3, the_matrix);//mutiply portfolio matrix(of time n) by budget share matrix(of time n+1) and store the results in the_matrix

   for (int i=0; i<3; i++)// compute matrix: Id-(1-cv)*the_matrix
   {
	   for (int j=0; j<3; j++)
	   {
		   if (j==i)
		   {
			   the_matrix[i][j]=1-(1-c*niu)*the_matrix[i][j];
		   }else{
               the_matrix[i][j]=0-(1-c*niu)*the_matrix[i][j];
		   }
	   }
   }

   double** Y = new double*[3];
   for (int i=0; i<3; i++)
	   Y[i]= new double[3]; 

   MatrixInversion(the_matrix, 3, Y);//compute the inverse of the result matrix, and store the result in matrix Y

   double** res_matrix = new double*[3];
   for (int i=0; i<3; i++)
	   res_matrix[i]= new double[m]; 

   Matrix_Mult(Y, portfolio, 3,3,m, res_matrix);//compute matrix Y times matrix portfolio, store the result in the_matrix

   for (int i=0; i<3; i++)// compute the_matrix times the dividend vector
   {
	   total=0;
	   for (int j=0; j<m; j++)
		total += dividend[j]*res_matrix[i][j];

	   wealth[i]=total;

	
	 
   }
  

    for (int i=0; i<3; i++)
   {
	   total=0;
	   for (int j=0; j<3; j++)
		total += bank[j]*Y[i][j];

	   wealth[i]=wealth[i]+total;	 
   }


	
   for (int i=0; i<3; i++)
   {
	   delete[] the_matrix[i];
	    delete[] Y[i];
		delete[] res_matrix[i];
   }

   delete[] the_matrix;

   //delete[] col_matrix;

   delete[] Y;

   delete[] res_matrix;


}

double normal_variate (void)
{
   static double value;
   static int stored = 0;

   if (stored)
   {
      stored = 0;
      return value;
   }

   double w, v1, v2;
   do {
      v1 = 2.0 * (rand () + 1.0) / (RAND_MAX + 1.0) - 1;
      v2 = 2.0 * (rand () + 1.0) / (RAND_MAX + 1.0) - 1;
      w = v1 * v1 + v2 * v2;
   } while (w >= 1.0);

   w = sqrt (-2.0 * log (w) / w);
   value = v2 * w;
   stored = 1;
   return v1 * w;
}


void price_matrix (double *price, double *dividend, double *market_return, double niu, int num_obs, int m,double **pri_matrix)
{
	
	int last, last_1;
	last = num_obs-1;
	last_1= num_obs-2;
	static int stored = 1;
	if (stored)//first time run
	{

      

	  for (int k=0; k<m; k++)
	  {   
	       pri_matrix[k][0]=950/pow(1.0015,(num_obs-1));

		for (int i=0; i<num_obs-1; i++)
		     pri_matrix[k][i+1]= pri_matrix[k][i]*1.0015;


		for(int j = 0; j<num_obs-1; j++)
		   market_return[j]=(pri_matrix[k][j+1]+1)/pri_matrix[k][j];
		   


		cout<<"initial prices: "<<pri_matrix[k][last]<<endl;

		price[0]=pri_matrix[k][last];
	  }
	  stored=0;
	}else{

		for (int k=0; k<m; k++)// re-assemble the price matrix with the new realised stock price
		{
			for (int i=0; i<num_obs-1; i++)
			{
			 pri_matrix[k][i]=pri_matrix[k][i+1];
			}

			pri_matrix[k][last]=price[k];//assign realised prices to the last column of the matrix


			for(int j = 0; j<num_obs-2; j++)
		    {
		      market_return[j]= market_return[j+1];
		   
		    }


			market_return[last_1]=(price[k]+dividend[0])/pri_matrix[k][last_1];

		}//end of for

	}//end of else
}//end of function


void portfolios(double **lamda, double *wealth, int m, double niu, double c, double r, double **portfolio, double *price, double *bank)
{
	for (int k=0; k<m; k++)
	{
        price[k]=lamda[k][0]*wealth[0]+lamda[k][1]*wealth[1]+lamda[k][2]*wealth[2];

		for (int i=0; i<3; i++)
        portfolio[i][k]=lamda[k][i]*wealth[i]/price[k];//get the portfolio for each investor

		price[k]=(1-c*niu)*price[k];//get the realised prices
	}

	for (int i=0; i<3; i++)
	{
        bank[i]=(1+r)*(1-c*niu)*lamda[m][i]*wealth[i];//get the portfolio of risk-free for each investor
	

	}

	



}



void Matrix_Mult(double **A, double **B, int Arow, int Acol, int Bcol, double **the_matrix)// compute the mutiplication of matrices
{
  
       for(int i = 0; i < Arow; i++) 
           for(int j = 0; j < Bcol; j++)
               for(int k = 0; k < Acol; k++) 
                   the_matrix[i][j] +=  A[i][k] * B[k][j];
}


void MatrixInversion(double **A, int order, double **Y)//compute the inverse of the matrix A and store the results in Y
{
    // get the determinant of A
    double det = 1.0/CalcDeterminant(A,order);

    // memory allocation
    double *temp = new double[(order-1)*(order-1)];
    double **minor = new double*[order-1];
    for(int i=0;i<order-1;i++)
        minor[i] = temp+(i*(order-1));

    for(int j=0;j<order;j++)
    {
        for(int i=0;i<order;i++)
        {
            // get the co-factor (matrix) of A(j,i)
            GetMinor(A,minor,j,i,order);
            Y[i][j] = det*CalcDeterminant(minor,order-1);
            if( (i+j)%2 == 1)
                Y[i][j] = -Y[i][j];
        }
    }

    // release memory
    delete [] minor[0];
    delete [] minor;
}

// calculate the cofactor of element (row,col)
int GetMinor(double **src, double **dest, int row, int col, int order)
{
    // indicate which col and row is being copied to dest
    int colCount=0,rowCount=0;

    for(int i = 0; i < order; i++ )
    {
        if( i != row )
        {
            colCount = 0;
            for(int j = 0; j < order; j++ )
            {
                // when j is not the element
                if( j != col )
                {
                    dest[rowCount][colCount] = src[i][j];
                    colCount++;
                }
            }
            rowCount++;
        }
    }

    return 1;
}

// Calculate the determinant recursively.
double CalcDeterminant( double **mat, int order)
{
    // order must be >= 0
	// stop the recursion when matrix is a single element
    if( order == 1 )
        return mat[0][0];

    // the determinant value
    double det = 0;

    // allocate the cofactor matrix
    double **minor;
    minor = new double*[order-1];
    for(int i=0;i<order-1;i++)
        minor[i] = new double[order-1];

    for(int i = 0; i < order; i++ )
    {
        // get minor of element (0,i)
        GetMinor( mat, minor, 0, i , order);
        // the recusion is here!
        det += pow( -1.0, i ) * mat[0][i] * CalcDeterminant( minor,order-1 );
    }

    // release memory
    for(int i=0;i<order-1;i++)
        delete [] minor[i];
    delete [] minor;

    return det;
}


