#include <iostream>
#include <cmath>
#include <time.h>
using namespace std;

double normal_variate (void);//compute standard normal sample
void price_matrix (double *price, double *dividend, double *market_return, double niu, int num_obs, int m,double **pri_matrix);
void compute_fundamental (double **pri_matrix, int num_obs, double r, double *lamda_F_1);
void compute_trend (double *market_return, int num_obs,  double r, double *lamda_T_1);
void compute_noise (double& noise_intensity, double *lamda_N_1);
void portfolios_flow(double **lamda, double *wealth,double *pre_population, int m, double niu, double beta, double c, double r, double& totalwealth, double **portfolio, double *price,double *bank);//compute portfolio matrix and the realised stock price
void compute_dividend (double *dividend);//compute dividend for each stock
void Matrix_Mult(double **A, double **B, int Arow, int Acol, int Bcol, double **the_matrix);// compute the mutiplication of matrices
void MatrixInversion(double **A, int order, double **Y);//compute the inverse of the matrix
double CalcDeterminant( double **mat, int order);//compute the determinant of the matrix
int GetMinor(double **src, double **dest, int row, int col, int order);//calculate the cofactor of element (row,col)



void compute_wealth_flow(double beta, double niu, double c, double r,int m, double& totalwealth, int num_obs, double **lamda, double *wealth, double *population, double *pre_population, double **portfolio, double **pri_matrix, double *price,double *bank, double& noise_intensity,double *dividend, double *lamda_F_1,double *lamda_T_1,double *lamda_N_1, double *market_return)
{
  double total,n_1,n_2,time_unit;
  double res[4];
  double res_2[4];
  double res_3[4];
  total=0;

  time_unit=0.25;

  portfolios_flow(lamda, wealth, pre_population, m, niu, beta, c, r, totalwealth, portfolio,price, bank); //compute portfolio matrix and the realised price

  price_matrix (price,dividend,market_return,niu,num_obs,m,pri_matrix);//get prices for each risky asset during observation time T_1

  compute_dividend (dividend);//compute dividend


  compute_fundamental (pri_matrix,num_obs,r,lamda_F_1);
  for (int i=0; i<m+1; i++)
	  lamda[i][1]=lamda_F_1[i];

  
  compute_noise (noise_intensity,lamda_N_1);
    for (int i=0; i<m+1; i++)
		lamda[i][0]=lamda_N_1[i];
				

  compute_trend (market_return, num_obs, r, lamda_T_1);
	 for (int i=0; i<m+1; i++)
		 lamda[i][2]=lamda_T_1[i];
		 

 
   double** the_matrix = new double*[3];
   for (int i=0; i<3; i++)
	   the_matrix[i]= new double[3]; 

   for (int i=0; i<3; i++)
	   for (int j=0; j<3; j++)
		     the_matrix[i][j] = 0;


   double** col_matrix = new double*[3];
   for (int i=0; i<3; i++)
	   col_matrix[i]= new double[3]; 

   for (int i=0; i<3; i++)
	   for (int j=0; j<3; j++)
		     col_matrix[i][j] = 0;


   Matrix_Mult(portfolio, lamda, 3,m,3, the_matrix);//mutiply portfolio matrix(of time n) by budget share matrix(of time n+1) and store the results in the_matrix

   

   for (int i=0; i<3; i++)// compute the_matrix times the dividend vector
   {
	   total=0;
	   for (int j=0; j<3; j++)
		total += population[j]*(1-c*niu)*beta*the_matrix[i][j];
	   
	   res[i]=total;
	  
   }

   for (int j=0; j<3; j++)
	   for (int i=0; i<3; i++)
		     col_matrix[i][j] = res[i];

   
    for (int i=0; i<3; i++)// compute matrix: Id-(1-cv)*the_matrix
   {
	   for (int j=0; j<3; j++)
	   {
		   if (j==i)
		   {
			   the_matrix[i][j]=1-col_matrix[i][j]-(1-c*niu)*(1-beta)*the_matrix[i][j];
		   }else{
               the_matrix[i][j]=0-col_matrix[i][j]-(1-c*niu)*(1-beta)*the_matrix[i][j];
		   }
	   }
   }


   double** Y = new double*[3];
   for (int i=0; i<3; i++)
	   Y[i]= new double[3]; 

   MatrixInversion(the_matrix, 3, Y);//compute the inverse of the result matrix, and store the result in matrix Y


   double** res_matrix = new double*[3];
   for (int i=0; i<3; i++)
	   res_matrix[i]= new double[m]; 

   Matrix_Mult(Y, portfolio, 3,3,m, res_matrix);//compute matrix Y times matrix portfolio, store the result in the_matrix

    for (int i=0; i<3; i++)// compute the_matrix times the dividend vector
   {
	   total=0;
	   for (int j=0; j<m; j++)
		total += dividend[j]*res_matrix[i][j];

	   wealth[i]=total;

	
	 
   }
  

    for (int i=0; i<3; i++)
   {
	   total=0;
	   for (int j=0; j<3; j++)
		total += bank[j]*Y[i][j];

	   wealth[i]=wealth[i]+total;
	  
	 
   }

	
   for (int i=0; i<3; i++)
   {
	   delete[] the_matrix[i];
	    delete[] col_matrix[i];
	    delete[] Y[i];
		delete[] res_matrix[i];
   }

   delete[] the_matrix;

   delete[] col_matrix;

   delete[] Y;

   delete[] res_matrix;


}



void portfolios_flow(double **lamda, double *wealth, double *pre_population, int m, double niu, double beta, double c, double r, double& totalwealth,double **portfolio, double *price,double *bank)
{

       for (int k=0; k<m; k++)
	  {
        price[k]=beta*totalwealth*(lamda[k][0]*pre_population[0]+lamda[k][1]*pre_population[1]+lamda[k][2]*pre_population[2])+(1-beta)*(lamda[k][0]*wealth[0]+lamda[k][1]*wealth[1]+lamda[k][2]*wealth[2]);

		for (int i=0; i<3; i++)
        portfolio[i][k]=(lamda[k][i]*pre_population[i]*totalwealth*beta+lamda[k][i]*wealth[i]*(1-beta))/price[k];//get the portfolio for each investor

		price[k]=(1-c*niu)*price[k];//get the realised prices
	  }


       for (int i=0; i<3; i++)
        bank[i]=(1+r)*(1-c*niu)*lamda[m][i]*(beta*pre_population[i]*totalwealth+(1-beta)*wealth[i]);//get the portfolio of risk-free for each investor

}





